commit 87be0dfefb8aa1e0b5fb83b88577960ee6a68e52
Author: freddy77 <freddy77>
Date:   Fri Oct 17 08:39:15 2008 +0000

    add tds_iconv_get to allow multiple client charsets

diff --git a/ChangeLog b/ChangeLog
index 14c7c29..30bfacd 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Oct 17 10:37:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsiconv.h src/tds/iconv.c:
+	- add tds_iconv_get to allow multiple client charsets
+
 Fri Oct 17 10:26:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
 	* src/odbc/odbc_util.c:
@@ -711,4 +715,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2624 2008/10/17 08:30:03 freddy77 Exp $
+$Id: ChangeLog,v 1.2625 2008/10/17 08:39:15 freddy77 Exp $
diff --git a/include/tdsiconv.h b/include/tdsiconv.h
index 49a91d6..3bd08fe 100644
--- a/include/tdsiconv.h
+++ b/include/tdsiconv.h
@@ -20,7 +20,7 @@
 #ifndef _tds_iconv_h_
 #define _tds_iconv_h_
 
-/* $Id: tdsiconv.h,v 1.36 2007/03/12 13:28:50 freddy77 Exp $ */
+/* $Id: tdsiconv.h,v 1.37 2008/10/17 08:39:16 freddy77 Exp $ */
 
 #if HAVE_ICONV
 #include <iconv.h>
@@ -166,6 +166,7 @@ size_t tds_iconv(TDSSOCKET * tds, const TDSICONV * char_conv, TDS_ICONV_DIRECTIO
 		 const char **inbuf, size_t * inbytesleft, char **outbuf, size_t * outbytesleft);
 const char *tds_canonical_charset_name(const char *charset_name);
 const char *tds_sybase_charset_name(const char *charset_name);
+TDSICONV *tds_iconv_get(TDSSOCKET * tds, const char *client_charset, const char *server_charset);
 
 #ifdef __cplusplus
 }
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 014fd57..89d1656 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.134 2008/10/06 13:45:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.135 2008/10/17 08:39:16 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -938,14 +938,15 @@ tds_iconv_fread(iconv_t cd, FILE * stream, size_t field_len, size_t term_len, ch
  * Get a iconv info structure, allocate and initialize if needed
  */
 static TDSICONV *
-tds_iconv_get_info(TDSSOCKET * tds, const char *canonic_charset)
+tds_iconv_get_info(TDSSOCKET * tds, const char *canonic_client_charset, const char *canonic_server_charset)
 {
 	TDSICONV *info;
 	int i;
 
 	/* search a charset from already allocated charsets */
 	for (i = tds->char_conv_count; --i >= initial_char_conv_count;)
-		if (strcmp(canonic_charset, tds->char_convs[i]->server_charset.name) == 0)
+		if (strcmp(canonic_client_charset, tds->char_convs[i]->client_charset.name) == 0
+		    && strcmp(canonic_server_charset, tds->char_convs[i]->server_charset.name) == 0)
 			return tds->char_convs[i];
 
 	/* allocate a new iconv structure */
@@ -972,10 +973,28 @@ tds_iconv_get_info(TDSSOCKET * tds, const char *canonic_charset)
 
 	/* init */
 	/* TODO test allocation */
-	tds_iconv_info_init(info, tds->char_convs[client2ucs2]->client_charset.name, canonic_charset);
+	tds_iconv_info_init(info, canonic_client_charset, canonic_server_charset);
 	return info;
 }
 
+TDSICONV *
+tds_iconv_get(TDSSOCKET * tds, const char *client_charset, const char *server_charset)
+{
+	int canonic_client_charset_num = tds_canonical_charset(client_charset);
+	int canonic_server_charset_num = tds_canonical_charset(server_charset);
+
+	if (canonic_client_charset_num < 0) {
+		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_get: what is charset \"%s\"?\n", client_charset);
+		return NULL;
+	}
+	if (canonic_server_charset_num < 0) {
+		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_get: what is charset \"%s\"?\n", server_charset);
+		return NULL;
+	}
+
+	return tds_iconv_get_info(tds, canonic_charsets[canonic_client_charset_num].name, canonic_charsets[canonic_server_charset_num].name);
+}
+
 /* change singlebyte conversions according to server */
 void
 tds_srv_charset_changed(TDSSOCKET * tds, const char *charset)
@@ -1002,7 +1021,7 @@ tds_srv_charset_changed(TDSSOCKET * tds, const char *charset)
 		return;
 
 	/* find and set conversion */
-	char_conv = tds_iconv_get_info(tds, canonic_charset);
+	char_conv = tds_iconv_get_info(tds, tds->char_convs[client2ucs2]->client_charset.name, canonic_charset);
 	if (char_conv)
 		tds->char_convs[client2server_chardata] = char_conv;
 
@@ -1460,7 +1479,7 @@ tds_iconv_from_collate(TDSSOCKET * tds, int sql_collate, int lcid)
 	if (strcmp(tds->char_convs[client2server_chardata]->server_charset.name, charset) == 0)
 		return tds->char_convs[client2server_chardata];
 
-	return tds_iconv_get_info(tds, charset);
+	return tds_iconv_get_info(tds, tds->char_convs[client2ucs2]->client_charset.name, charset);
 }
 
 /** @} */

